/**
 * 
 */
package org.gcube.accounting.datamodel.persistence;

import org.codehaus.jackson.JsonNode;
import org.gcube.accounting.datamodel.UsageRecord;
import org.gcube.accounting.persistence.CouchDBPersistence;
import org.gcube.accounting.persistence.Persistence;
import org.junit.Assert;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Luca Frosini (ISTI - CNR) http://www.lucafrosini.com/
 *
 */
public class CouchDBPersistenceTest {
	
	private static final Logger logger = LoggerFactory.getLogger(CouchDBPersistenceTest.class);
	
	@Test
	public void TestJsonNodeUsageRecordConversions() throws Exception {
		UsageRecord usageRecord = Persistence.createTestUsageRecord();
		logger.debug("UsageRecord : {}", usageRecord.toString());
		JsonNode node = CouchDBPersistence.usageRecordToJsonNode(usageRecord);
		logger.debug("Node : {}", node.toString());
		UsageRecord ur = CouchDBPersistence.jsonNodeToUsageRecord(node);
		Assert.assertEquals(0, usageRecord.compareTo(ur));
		Assert.assertEquals(0, ur.compareTo(usageRecord));
	}
}
