/**
 * 
 */
package org.gcube.accounting.datamodel.persistence;

import java.util.Calendar;
import java.util.GregorianCalendar;

import org.gcube.accounting.datamodel.UsageRecord;
import org.gcube.accounting.persistence.Persistence;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Luca Frosini (ISTI - CNR) http://www.lucafrosini.com/
 *
 */
public class PersistenceTest {
	
	private static final Logger logger = LoggerFactory.getLogger(PersistenceTest.class);
	
	@Test
	public void test() throws Exception {
		Persistence persistence = Persistence.getInstance();
		persistence.connect();
	}
	
	@Test
	public void stressTest() throws Exception {
		Persistence persistence = Persistence.getInstance();
		persistence.connect();
		int quantity = 3000;
		Calendar startTestTime = new GregorianCalendar();
		for(int i=0; i< quantity; i++){
			UsageRecord usageRecord = Persistence.createTestUsageRecord();
			persistence.account(usageRecord);
		}
		Calendar stopTestTime = new GregorianCalendar();
		double startMillis = startTestTime.getTimeInMillis();
		double stopMillis = stopTestTime.getTimeInMillis();
		double duration = stopMillis - startMillis;
		double average =  (duration/quantity);
		logger.debug("Duration (in millisec) : " + duration);
		logger.debug("Average (in millisec) : " + average);
	}
	
}
